/*******************************************************************************
*  This file contains definitions and structs used be both the SS.C and SSI.C  *
*******************************************************************************/

/* Option type : Switches */
#define OPTION_DESC          "-sd"
#define OPTION_STATS         "-ss"

/* Option type : Search conditions */
#define OPTION_AUTHOR        "-a="
#define OPTION_XAUTHOR       "-xa="
#define OPTION_OAUTHOR       "-oa="
#define OPTION_COMPONENTS    "-c="
#define OPTION_XCOMPONENTS   "-xc="
#define OPTION_OCOMPONENTS   "-oc="
#define OPTION_DURATION      "-d="
#define OPTION_XDURATION     "-xd="
#define OPTION_ODURATION     "-od="
#define OPTION_AREAOFEFFECT  "-e="
#define OPTION_XAREAOFEFFECT "-xe="
#define OPTION_OAREAOFEFFECT "-oe="
#define OPTION_DESCRIPTION   "-i="
#define OPTION_XDESCRIPTION  "-xi="
#define OPTION_NAME          "-n="
#define OPTION_XNAME         "-xn="
#define OPTION_ONAME         "-on="
#define OPTION_LEVEL         "-l="
#define OPTION_SPHERE        "-p="
#define OPTION_XSPHERE       "-xp="
#define OPTION_OSPHERE       "-op="
#define OPTION_RANGE         "-r="
#define OPTION_XRANGE        "-xr="
#define OPTION_ORANGE        "-or="
#define OPTION_SCHOOL        "-s="
#define OPTION_XSCHOOL       "-xs="
#define OPTION_OSCHOOL       "-os="
#define OPTION_CASTINGTIME   "-t="
#define OPTION_XCASTINGTIME  "-xt="
#define OPTION_OCASTINGTIME  "-ot="
#define OPTION_SAVINGTHROW   "-v="
#define OPTION_XSAVINGTHROW  "-xv="
#define OPTION_OSAVINGTHROW  "-ov="

#define TRUE  1
#define FALSE 0

#define MAXLINELENGTH       150

/* Structures */
typedef struct _squery_t {
  char AreaOfEffect[20],
       XAreaOfEffect[20],
       OAreaOfEffect[20],
       Author[50],
       XAuthor[50],
       OAuthor[50],
       CastingTime[20],
       XCastingTime[20],
       OCastingTime[20],
       Components[10],
       XComponents[10],
       OComponents[10],
       Description[20],
       XDescription[20],
       Duration[20],
       XDuration[20],
       ODuration[20],
       Name[50],
       XName[50],
       OName[50],
       Range[50],
       XRange[50],
       ORange[50],
       SavingThrow[20],
       XSavingThrow[20],
       OSavingThrow[20],
       School[50],
       XSchool[50],
       OSchool[50],
       Sphere[50],
       XSphere[50],
       OSphere[50];
  int  MaxLevel,
       MinLevel,
       PrintDesc,
       PrintStats;
} squery_t;

/* Function forward declarations */
void InitQuery(squery_t *);


/*******************************************************************************
* FUNCTION : InitQuery                                                         *
*******************************************************************************/
void InitQuery(squery_t *Query) {

  Query->MinLevel   = 0;          /* Default is to include lower range level query      */
  Query->MaxLevel   = 10;         /* Default is to include upper range level query      */
  Query->PrintDesc  = FALSE;      /* Default is not to print spell description          */
  Query->PrintStats = FALSE;      /* Default is not to print spell search statistics    */
  Query->AreaOfEffect[0]  = '\0'; /* Default is not to include area of effect query     */
  Query->XAreaOfEffect[0] = '\0'; /* Default is not to exclude area of effect query     */
  Query->OAreaOfEffect[0] = '\0'; /* Default is not to or      area of effect query     */
  Query->Author[0]        = '\0'; /* Default is not to include author query             */
  Query->XAuthor[0]       = '\0'; /* Default is not to exclude author query             */
  Query->OAuthor[0]       = '\0'; /* Default is not to or      author query             */
  Query->CastingTime[0]   = '\0'; /* Default is not to include casting time query       */
  Query->XCastingTime[0]  = '\0'; /* Default is not to exclude casting time query       */
  Query->OCastingTime[0]  = '\0'; /* Default is not to or      casting time query       */
  Query->Components[0]    = '\0'; /* Default is not to include component query          */
  Query->XComponents[0]   = '\0'; /* Default is not to exclude component query          */
  Query->OComponents[0]   = '\0'; /* Default is not to or      component query          */
  Query->Description[0]   = '\0'; /* Default is not to include description query        */
  Query->XDescription[0]  = '\0'; /* Default is not to exclude description query        */
  Query->Duration[0]      = '\0'; /* Default is not to include duration query           */
  Query->XDuration[0]     = '\0'; /* Default is not to exclude duration query           */
  Query->ODuration[0]     = '\0'; /* Default is not to or      duration query           */
  Query->Name[0]          = '\0'; /* Default is not to include name query               */
  Query->XName[0]         = '\0'; /* Default is not to exclude name query               */
  Query->OName[0]         = '\0'; /* Default is not to or      name query               */
  Query->Range[0]         = '\0'; /* Default is not to include range query              */
  Query->XRange[0]        = '\0'; /* Default is not to exclude range query              */
  Query->ORange[0]        = '\0'; /* Default is not to or      range query              */
  Query->SavingThrow[0]   = '\0'; /* Default is not to include saving throw query       */
  Query->XSavingThrow[0]  = '\0'; /* Default is not to exclude saving throw query       */
  Query->OSavingThrow[0]  = '\0'; /* Default is not to or      saving throw query       */
  Query->School[0]        = '\0'; /* Default is not to include school query             */
  Query->XSchool[0]       = '\0'; /* Default is not to exclude school query             */
  Query->OSchool[0]       = '\0'; /* Default is not to or      school query             */
  Query->Sphere[0]        = '\0'; /* Default is not to include sphere query             */
  Query->XSphere[0]       = '\0'; /* Default is not to exclude sphere query             */
  Query->OSphere[0]       = '\0'; /* Default is not to exclude sphere query             */
}
